#ifndef __ENDEXE_H__
#define __ENDEXE_H__

#ifdef __cplusplus
extern "C" {
#endif


#define MARKER_ENDEXE_HEADER "AKGUBDPLM"
#define MARKER_ENDEXE_RECORD "ZZEDFGGGD"

#define TYPE_IMG_BMP	1
#define TYPE_IMG_JPG	2
#define TYPE_IMG_GIF	3
#define TYPE_IMG_PNG	4

typedef struct _tagHeaderEndExe
{
int cbSize;
char Marker[10];
BOOL fParamEnable;
BOOL fExitOnClose;
BOOL fCloseWhenLastImage;
int TimeSecClose;
} HeaderEndExe;

typedef struct _tagRecordEndExe
{
int cbSize;
char Marker[10];
char szImgFile[30];
char szWavFile[30];
char szTitle[200];
int cbImgFile;
int cbWavFile;
UINT fImgType;
BOOL fWallPaper;
} RecordEndExe;


BOOL LoadExeHeader( char * pszExeName, BOOL *pfParamEnable, BOOL *pfExitOnClose,
	BOOL *pfCloseWhenLastImage, int *pTimeSecClose  );
BOOL AddFileInExe( char * pzsExeName, char * pszImgFile, char * pszWavFile, 
	BOOL fParamEnable, BOOL fExitOnClose, char * pszTitle, int TimeSecClose, 
	BOOL fCloseWhenLastImage, BOOL fWallPaper );
BOOL RemoveAllFilesFromExe( char * pszExeName );
int CreateJpgAndWavFileInTempDir( char * pszImgFile, BOOL * pfType, 
	char * pszWavFile, BOOL * pfExitOnClose, char * pszTitle, int * pTimeSecClose, 
	BOOL *pfCloseWhenLastImage, BOOL * pfWallPaper );



#ifdef __cplusplus
}
#endif

#endif	/*__ENDEXE_H__*/	